#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
#include <owl\choosefo.h>
#include <string.h>
#include "pr27_1.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw : public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
         ~TWndw();
  protected:
         TFont *font;
         TColor fontColor;
         char fontName[81];
         void CmChooseFont();
         void  Paint (TDC &paintDC, BOOL, TRect&);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_COMMAND(CM_CHOOSEFONT, CmChooseFont),
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=GetSystemMetrics(SM_CXSCREEN)/3;
	Attr.H=GetSystemMetrics(SM_CXSCREEN)/4;
        //   ,   .
        font = 0;
        fontColor = TColor::Black;
        strcpy(fontName,"System font");
}

// TWndw::~TWndw()
//    .
TWndw::~TWndw()
{
  //    ,  .
  if (font) delete font;
}

// TWndw::CmChooseFont()
//      Choose Font,
//    "".
void TWndw::CmChooseFont()
{
  //      .
  char errorMsg[81];
  //   TData   Font.
  TChooseFontDialog::TData fontData;
  //   TData. 
  fontData.Flags = CF_EFFECTS | CF_TTONLY | 
     CF_FORCEFONTEXIST | CF_SCREENFONTS;
  fontData.Color = fontColor;
  //    Font.
  TChooseFontDialog *dialog =
       new TChooseFontDialog (this, fontData);
  //    Font. 
  int result = dialog->Execute();
  //    "OK"  .
  if (result == IDOK)
  {
      //   ,   .
      if (font) delete font;
      //      . 
      font = new TFont(&fontData.LogFont);
      //      .
      fontColor = fontData.Color;
      strcpy(fontName, fontData.LogFont.lfFaceName);
      //   . 
      Invalidate();
  }
  //   ... 
  else if (fontData.Error != 0) 
         {
           //     . 
           wsprintf(errorMsg," #%ld.", fontData.Error); 
           MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
         }
}

//TWndw::Paint()
//     Paint()  
// TWindow     WM_PAINT,  
// Windows  ,     
//  .
void TWndw::Paint(TDC &paintDC, BOOL, TRect&)
{
  //    ...
  if (font)
        // ...     .
        paintDC.SelectObject (*font); 
  //   .
  paintDC.SetTextColor (fontColor);  
  //     . 
  paintDC.TextOut(10, 10, fontName);
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw= new TWndw(0,"  \" \"");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
